## 简要介绍
### 什么是 grpc ?
```azure
gRPC是rpc框架中的一种，是一个高性能，开源和通用的RPC框架，基于Protobuf序列化协议开发，且支持众多开发语言。

gRPC可以通俗的理解为google对于RPC的一种实现形式。
```

### grpc 特性
```azure
grpc可以跨语言使用。支持多种语言 支持C++、Java、Go、Python、Ruby、C#、Node.js、Android Java、Objective-C、PHP等编程语言
基于 IDL ( 接口定义语言（Interface Define Language）)文件定义服务，通过 proto3 工具生成指定语言的数据结构、服务端接口以及客户端 Stub；
通信协议基于标准的 HTTP/2 设计，支持·双向流、消息头压缩、单 TCP 的多路复用、服务端推送等特性，这些特性使得 gRPC 在移动端设备上更加省电和节省网络流量；
序列化支持 PB（Protocol Buffer）和 JSON，PB 是一种语言无关的高性能序列化框架，基于 HTTP/2 + PB, 保障了 RPC 调用的高性能。
安装简单，扩展方便（用该框架每秒可达到百万个RPC）
```

### 什么是 Protocol Buffers ？
```azure
gRPC默认使用protocl buffers(简称 Protobuf)，Protobuf 是谷歌成熟的开源的用于结构化数据序列化的机制存储方案，类似于XML、Json。
    
```
![image-20220113153420444](static/images/protocol.webp)


### 使用Protocol Buffers

- 第一步：使用 .proto文件（以.proto为后缀的二进制文本文件）定义待序列化数据的结构
```azure
message Person {
  string name = 1;
  int32 id = 2;
  bool has_ponycopter = 3;
}
```
- 第二步：使用 protocol buffer 的编译器protoc从proto定义生成选择语言的数据接入层类。
```azure
// greeter 服务定义.
service Greeter {
  // Sends a greeting
  rpc SayHello (HelloRequest) returns (HelloReply) {}
}

// 客户端请求消息包含用户名.
message HelloRequest {
  string name = 1;
}

// 服务端响应包含一条greeting消息
message HelloReply {
  string message = 1;
}
```

gRPC使用带有特殊gRPC插件的protoc来生成proto文件中的代码。 但是，使用gRPC插件，您可以生成gRPC客户端和服务器代码，以及用于填充，序列化和检索消息类型的常规protocol buffer 代码。你可以从Protocol Buffers文档中获取到更多有关protocol buffer的信息，并能够获取到如何获取安装和你选定语言相关的protoc。

### Protocol buffer 版本

```
虽然protocol buffer 被开源用户使用已经有一段时间，但我们的示例使用了一种新的protocol buffer，称为proto3，它具有略微简化的语法，一些有用的新功能，并支持更多语言。
proto3目前已经支持Java，C++，Python，Objective-C，C#，Ruby和JavaScript，也实现了对Go语言的支持。
通常，虽然也可以使用proto2（当前默认protocol buffer版本），但建议将proto3与gRPC一起使用，因为它允许您使用全系列gRPC支持的语言，
并避免使用proto2客户端与使用proto3服务端通信时的兼容性问题，反之亦然。
```

